from pawt import swing
from pawt import GridBag
RIGHT = swing.JLabel.RIGHT
APPROVE_OPTION = swing.JFileChooser.APPROVE_OPTION
import java.io
import pickle
import os
from Console import Console

class GUI:

    def __init__(self):
        self.frame = swing.JFrame("Coopr", windowClosing=self._fileQuit)
        self.frame.JMenuBar = self.create_menubar()

        bag = GridBag(self.frame.contentPane, \
                        fill='BOTH', weightx=1.0)

        # do the rest of the layout in a GridBag
        #self.do_layout(bag)
        c = Console()
        pane = swing.JScrollPane(c.textpane,\
                    verticalScrollBarPolicy=swing.JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
                    size=(1000,10000))
        #pane.minimizeSizeSet(10,10)
        bag.addRow(pane, weighty=1.0)
        bag.addRow(swing.JLabel("Coopr version VERSION (DATE)"))

        # Create a file chooser
        self.chooser = swing.JFileChooser()
        self.chooser.currentDirectory = java.io.File(os.getcwd())
        # Start Console
        c.write("DRAFT COOPR CONSOLE GUI\n\n"+Console.header, 'output')
        c.capturePythonOutput()
	c.textpane.requestFocus()
	c.newInput()
        # Finish up and set the size
        self.frame.pack()
        self.frame.visible = 1
        self.frame.size = self.frame.getPreferredSize()

    def create_menubar(self):
        """build menu bar"""
        menubar = swing.JMenuBar()
        #
        file = swing.JMenu("File")
        file.add(swing.JMenuItem("Load...", actionPerformed = self._fileLoad))
        file.add(swing.JMenuItem("Save...", actionPerformed = self._fileSave))
        file.add(swing.JMenuItem("Save to file...", actionPerformed = self._fileSaveToFile))
        file.add(swing.JMenuItem("Quit", actionPerformed = self._fileQuit))
        menubar.add(file)
        #
        file = swing.JMenu("Edit")
        file.add(swing.JMenuItem("Copy", actionPerformed = self._editCopy))
        file.add(swing.JMenuItem("Paste", actionPerformed = self._editPaste))
        file.add(swing.JMenuItem("Quit", actionPerformed = self._editSelectAll))
        file.add(swing.JMenuItem("Clear console", actionPerformed = self._editClearConsole))
        menubar.add(file)
        #
        file = swing.JMenu("Packages")
        file.add(swing.JMenuItem("Versions", actionPerformed = self._packagesVersions))
        file.add(swing.JMenuItem("Install...", actionPerformed = self._packagesInstall))
        file.add(swing.JMenuItem("Update...", actionPerformed = self._packagesUpdate))
        menubar.add(file)
        #
        file = swing.JMenu("Help")
        file.add(swing.JMenuItem("Console", actionPerformed = self._helpConsole))
        file.add(swing.JMenuItem("COIN-OR wiki", actionPerformed = self._helpCoinWiki))
        file.add(swing.JMenuItem("Coopr wiki", actionPerformed = self._helpCooprWiki))
        file.add(swing.JMenuItem("About", actionPerformed = self._helpAbout))
        menubar.add(file)
        return menubar

    def _fileLoad(self, event=None):
        self.chooser.rescanCurrentDirectory()
        returnVal = self.chooser.showOpenDialog(self.frame)
        if returnVal == APPROVE_OPTION:
            file = open(os.path.join(self.chooser.currentDirectory.path,
                     self.chooser.selectedFile.name))
            (setup, each, style, color,
             colorname, self.numelements) = pickle.load(file)
            file.close()
            self.chart.color = java.awt.Color(color)
            self.colorname.selectedIndex = colorname
            self.chart.style = style
            self.execentry.text = setup
            self.numpoints.selectedIndex = self.sizes.index(self.numelements)
            self.evalentry.text = each
            self.update(None)

    def _fileSave(self, event=None):
        self.chooser.rescanCurrentDirectory()
        returnVal = self.chooser.showSaveDialog(self.frame)
        if returnVal == APPROVE_OPTION:
            object = (self.execentry.text,  self.evalentry.text,
                      self.chart.style,
                      self.chart.color.RGB,
                      self.colorname.selectedIndex,
                      self.numelements)
            file = open(os.path.join(self.chooser.currentDirectory.path,
                        self.chooser.selectedFile.name), 'w')
            pickle.dump(object, file)
            file.close()

    def _fileSaveToFile(selfself, event=None):
        pass

    def _fileQuit(self, event=None):
        import sys
        sys.exit(0)

    def _editCopy(selfself, event=None):
        pass

    def _editPaste(selfself, event=None):
        pass

    def _editSelectAll(selfself, event=None):
        pass

    def _editClearConsole(selfself, event=None):
        pass

    def _helpConsole(selfself, event=None):
        pass

    def _helpCoinWiki(selfself, event=None):
        pass

    def _helpCooprWiki(selfself, event=None):
        pass

    def _helpAbout(selfself, event=None):
        pass

    def _packagesVersions(selfself, event=None):
        pass

    def _packagesInstall(selfself, event=None):
        pass

    def _packagesUpdate(selfself, event=None):
        pass


def run():
    GUI()

if __name__ == '__main__':
    run()
